This service will be undergoing maintenance at 20:00 UTC, 2017-04-03. It is expected to last about 30 minutes
Bug 585384 - Multiple triggers with identical conditions don't run
Multiple triggers with identical conditions don't run
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: packaging-team-maint
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-23 16:34 EDT by Christian Lupien
Modified: 2015-04-27 10:22 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-04-27 10:22:14 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Reproducer specfile (575 bytes, text/plain)
2010-04-23 16:59 EDT, Ville Skyttä
no flags Details

  None (edit)
Description Christian Lupien 2010-04-23 16:34:18 EDT
Description of problem:

I have xorg-x11-server-utils installed and when I install bash-completion a lot of symbolic link in /etc/bash_completion.d are created to files in /usr/share/bash-completion/ by trigger scripts in bash-completion. However the xrandr script is not installed (no symbolic link) so it is not available (unless manually creating link).


Version-Release number of selected component (if applicable):
xorg-x11-server-utils-7.4-13.fc12.x86_64
bash-completion-1.1-6.fc12.noarch


How reproducible:
Always

Steps to Reproduce:
1. Make sure xorg-x11-server-utils is installed
2. Install bash-completion: yum install bash-completion
  
Actual results:
The symbolic link /etc/bash_completion.d/xrandr does not exists.

Expected results:
The symbolic link /etc/bash_completion.d/xrandr should exists.

Additional info:
I think the problem is that there are 2 triggerin scriptlet attached to 
xorg-x11-server-utils in the bash-completion package. The first one is for xhost, the second one is for xrandr. While xrandr is not installed properly, xhost seems fine. 

Therefore there is probably a limit in rpm preventing duplicate triggers from working properly. So the xhost and xrandr should be merged into one triggerin.
Comment 1 Ville Skyttä 2010-04-23 16:57:57 EDT
This smells like bug 490378 in rpm which I believe was fixed sometime but has apparently broken again, both in F-12 and F-13.
Comment 2 Ville Skyttä 2010-04-23 16:59:45 EDT
Created attachment 408738 [details]
Reproducer specfile

Should output on install:

triggerin 1
triggerin 2

...but outputs only:

triggerin 1

Ditto on erase.
Comment 3 Ville Skyttä 2010-04-23 17:02:52 EDT
(In reply to comment #1)
> This smells like bug 490378 in rpm

Not exactly the same though, but see bug 490378 comment 3.
Comment 4 Jeff Johnson 2010-04-24 23:42:55 EDT
There has always been a limit to no.of triggers run. Only the
first trigger (of multiple) is run, no matter whether it "smells"
like a bug (or not).
Comment 5 Ville Skyttä 2010-06-17 15:14:09 EDT
rpm-4.8.0-14.fc13.x86_64 is affected.
Comment 6 Fedora Update System 2010-06-20 06:57:11 EDT
bash-completion-1.2-1.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/bash-completion-1.2-1.fc13
Comment 7 Fedora Update System 2010-07-01 15:00:05 EDT
bash-completion-1.2-2.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 8 Fedora Update System 2010-10-04 13:27:53 EDT
bash-completion-1.2-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/bash-completion-1.2-3.el5
Comment 9 Fedora Update System 2010-10-25 12:34:25 EDT
bash-completion-1.2-4.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Bug Zapper 2011-06-02 10:55:53 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Christian Lupien 2011-06-02 18:53:02 EDT
It was fixed on F13 at least, I don't have a F12 machine anymore.
Comment 12 Ville Skyttä 2011-06-03 16:20:52 EDT
It was worked around in bash-completion, but the underlying problem (see comment 2 for a reproducer) still persists at least in F-14.
Comment 13 Fedora End Of Life 2012-08-16 15:50:28 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Ville Skyttä 2012-09-23 14:11:20 EDT
Still happens with rpm-4.10.0-6.fc18.x86_64 in current rawhide.
Comment 15 Fedora End Of Life 2013-04-03 16:12:15 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 16 Fedora End Of Life 2015-01-09 16:43:32 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 17 Ville Skyttä 2015-01-24 17:17:37 EST
rpm-4.12.0.1-6.fc22.x86_64 is still affected.
Comment 18 Ľuboš Kardoš 2015-03-20 09:29:38 EDT
Fixed in upstream. Command rpmbuild now complains about multiple triggers triggered by the same package in one spec file.
Comment 19 Ville Skyttä 2015-03-23 06:01:52 EDT
https://github.com/rpm-software-management/rpm/commit/3ae1c414f69a0eddbfecd4341dd27c7a5e90e12a

What about trigger versioning, i.e. let's say one for foo < 1.0 and another for foo >= 2.0, this will probably prohibit specifying them as if I read the commit correctly it looks for package names only, no?

Not preventing multiple for same package but just running them all would be another approach, see comment 2.

BTW, what's upstream nowadays? The fix seems to be in https://github.com/rpm-software-management/rpm but http://rpm.org/wiki/GetSource still says git is at http://rpm.org/git/
Comment 20 Florian Festi 2015-03-24 11:18:51 EDT
Authorative upstream is the GitHub repository. I just setup the syncronization to the old repo on rpm.org. Also see my mail in the RPM mailing lists.
Comment 21 Ľuboš Kardoš 2015-04-24 06:07:40 EDT
Yes, you read the commit correctly, I modified that behaviour and now it also allowed to have e.g. two file triggers fired by "foo < 1.0" and "foo >= 2.0" in the same spec file: 77146f94b598079a24ab779f71e6c2ebf151cd24
Comment 22 Ville Skyttä 2015-04-27 10:22:14 EDT
Thanks.

Note You need to log in before you can comment on or make changes to this bug.